<template>
    <!-- #################  S-MU-03 ##################33 -->
    <div class="frame-content">
        <a href="" @click.prevent="$emit('remove')">
            <i class=" ti-trash trash-content"></i>
        </a>
        <span class="float-option-detail">
            <b>{{ index +1 }} de {{ length }} páginas</b>
        </span>
		<span class="float-option-detail hidden-sm-down">{{ config.id }}</span>
        <div class="float-option-image"><img class="" :src="config.portrait"></div>
        <form class="form-material">
            <div class="form-group row">
                <div class="col-sm-8">
                    <input type="name" class="form-control form-control-lg" id="input" placeholder="Título" v-model="value.title">
                </div>
                <div class="col-sm-12">
                    <textarea class="form-control form-control-lg " id="exampleTextarea" placeholder="Descripción del contenedor" rows="4" v-model="value.body"></textarea>
                </div>
                <div class="col-sm-6" data-toggle="modal" data-target=".large-modal2" @click="toggleGallery()">
                    <br> Selecciona la imagen
                </div>
                <div class="col-md-12">
                    <div class="bubble-wrap">
					<span :class="imgTypeStyle">
						<b><small data-toggle="tooltip" data-placement="top" title="" data-original-title="Toma en cuenta estos datos al guardar la imágen."> 
							{{ _name }} 
						</small></b>
					</span>
                        <canvas class="bubble-image" :style="bg" ref="container" @click="addBubble"></canvas>
                        <template v-for="(bubble, index) in value.bubbles">
                            <div class="circle" :key="index" :style="bubble.style" @click="removeBubble(bubble)">
                                {{ index + 1 }}
                            </div>
                        </template>
                    </div>
                </div>
                <div class="col-sm-12 mt-2 mb-2 separador-content"></div>
                <div class="col-sm-4 bg-dot" :key="index" v-for="(item, index) in value.bubbles">
                    <div class="col-sm-12">
                        <h5> Burbuja {{ index+1 }} </h5>
                    </div>
                    <div class="col-sm-12">
                        <input type="name" class="form-control " id="input" placeholder="Título" v-model="item.value.title">
                        <textarea class="form-control  " id="exampleTextarea" placeholder="Descripción " rows="4" v-model="item.value.description"></textarea>
                    </div>
                </div>
                    <div class="col-sm-12 mt-2">
                        <a class="note-content-icon" data-toggle="collapse" :href="`#${config.props.id}-${index}`" aria-expanded="false" :aria-controls="`${config.props.id}-${index}`">
                            <div class="note-content">
                                <h2>
                                    <i class="ti-arrow-circle-down"></i> Mis apuntes
                                </h2>
                            </div>
                        </a>
                        <div class="collapse" :id="`${config.props.id}-${index}`">
                            <textarea class="form-control form-control" placeholder="Tus apuntes: Guiones, Audios, explicaciones de diseño etc." rows="5" v-model="value.notes"></textarea>
                        </div>
                    </div>
            </div>
        </form>
    </div>
</template>
<script>	

import { mapGetters } from 'vuex'
import { config } from './config'

export default {

    data() {
        return {
            config,
            bubbleLeft : 0,
            lastBubble : -1,
            hasCompletedBubbles: false
        }
    },
    computed: {
        ...mapGetters(['courseBuilderInfo', 'tempSessionBuilderWeek']),
		_name(){
			let name = ''
            let week_index   = this.tempSessionBuilderWeek < 10 ? `0${this.tempSessionBuilderWeek + 1}` : this.tempSessionBuilderWeek + 1 
            let courseAcronym = this.courseBuilderInfo.name.slice(0, 3).toUpperCase();
            let media_index  = this.uploadableindex < 10 ? `0${this.uploadableindex + 1}` : this.uploadableindex + 1 
				name = `SEM-${week_index}-${courseAcronym}-${media_index}`
				this.value.imgName = name
			if(! this.isEditing){
				return name
			}
			else{
				return this.value.imgName == '' ? this.value.imgName : name
			}
		},
		imgTypeStyle(){
            return this.value.imgType == 'reference' ? 'float-option-detail-reference' : this.value.imgType == 'default' ? 'float-option-detail-2' :'float-option-detail-final'
        },
        bg() {
            return {
                "background": `url('${this.value.img}') no-repeat`,
                "background-size": "contain"
            }
        }
    },
    name: config.component,
	props: {
		...config.props,
		length: {
			type: Number,
		},
		index: {
			type: Number,
		},
		fileuploadedinfo: {
			type: Object,
		},
		uploadableindex: {
			type: Number
		},
		uploadableindexin: {
			type: Number
		},
	},
    methods: {
		toggleGallery(){
			this.$emit('togglegallery', {trigger: this.index, mediaIndex: this.uploadableindex, name: this._name, current_image: this.value.img})
		},
        addBubble(e) {
            let pos = this.getCursorPosition(e)
            if(this.value.bubbles.length == config.options.bubbles){
                if(this.isEditing){
                    this.value.bubbles[this.lastBubble].style.display = 'inline-grid'
                    this.value.bubbles[this.lastBubble].style.left = `${pos.x}%`
                    this.value.bubbles[this.lastBubble].style.top  = `${pos.y}%`
                    this.isEditing = false
                }else{
                    toastr.error(`No se pueden añadir mas de ${config.options.bubbles} burbujas`)
                    return ;
                }
            }
            else{
                this.value.bubbles.push({
                    "style": {
                        "position": "absolute",
                        "left": pos.x + '%',
                        "top":  pos.y + '%',
                        "display": "inline-grid",
                    },
                    "value": {
                        "title": "",
                        "description": ""
                    }
                })
            }
        },
        removeBubble(bubble) {
            let index = this.value.bubbles.indexOf(bubble)
            if(!this.isEditing){
                this.value.bubbles[index].style.display = "none"
                this.lastBubble = index
                this.isEditing = true
                toastr.info(`Haga click en la posicion donde desea colocar la burbuja`, 'Bien, ahora...')
            }else{
                toastr.warning(`Primero coloque la burbuja en la posición deseada`, 'Atención')
            }
        },
        getCursorPosition(event) {
            let canvas = this.$refs.container
            let rect = canvas.getBoundingClientRect()
            let xRel = event.clientX - rect.left
            let yRel = event.clientY - rect.top
            let x = (xRel / canvas.offsetWidth) * 100
            let y = (yRel / canvas.offsetHeight) * 100
            return { "x": x, "y": y }
        }
    }, 
    watch : {
        value: {
            handler(val){
                if(val.bubbles.length >= config.options.bubbles){
                    this.hasCompletedBubbles = true
                }
            },
            deep : true
        }
    }
}
</script>
<style>
	.circle{
		display: flex;
		justify-content: center;
		align-content: center;
		width: 30px;
		height: 30px;
		border-radius: 50%;
		background: #3cfd92;		
	  	color: #4f4c4c;
	}
	.bubble-image{
		position: relative;
		width: 100%;
		height: 300px;
	}
	.bubble-wrap{
		position: relative;
	}

.float-option-detail-reference {
    background: #20b9ae;
    padding: 3px 14px;
    color: #fff;
    /*left: -8%;*/
    top: 10px;
    left: 5px;
    position: relative;
    border-radius: 6px;
    width: 100%;
    z-index: 5;
}
.float-option-detail-final {
    background: #43b968;
    padding: 3px 14px;
    color: #fff;
    /*left: -8%;*/
    top: 10px;
    left: 5px;
    position: relative;
    border-radius: 6px;
    width: 100%;
    z-index: 5;
}
</style>
